# Kubernetes

### [List of Kubernetes xRunBooks](https://github.com/unskript/docs/blob/main/connnecting/connectors/kubernetes/broken-reference/README.md)

### [List of Kubernetes Actions](https://github.com/unskript/docs/blob/main/connnecting/connectors/kubernetes/action_kubernetes.md)

### Authentication

![Information needed to onboard kubernetes connector](https://491011674-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fm4p7lGuBAXN5jCVyoF7P%2Fuploads%2FWAcqrk3TX7YEsxJg16Ng%2FScreen%20Shot%202022-06-14%20at%206.03.08%20PM.png?alt=media\&token=801a374e-0d8f-484a-b52b-f081ba71f7eb)

| Name       | Description                                                                              |
| ---------- | ---------------------------------------------------------------------------------------- |
| Name       | This credential will be listed using the name you provide                                |
| Kubeconfig | Contents of the kubeconfig file, typically found in the .kube directory of your cluster. |

**Authentication in Kubeconfig**

The authentication of the command used to call an EKS cluster is done using the role assigned during SSO login of the AWS console. unSkript's proxy also has a role assigned to it which needs to have access to the client's EKS cluster.

We can specify the IAM Instance Role for an EC2 instance to enable authentication which is used by the unSkript proxy to talk to the client cluster.

To do so, edit the aws-auth ConfigMap. You can use a tool such as eksctl to update the ConfigMap or you can update it manually by editing it. You can read[ here](https://docs.aws.amazon.com/eks/latest/userguide/add-user-role.html) for detailed steps to enabling user and role access.

**Ensuring Connectivity for Amazon EKS VPC**

In order to ensure connectivity to unSkript's proxy from a private cluster, the VPC cluster security group should allow traffic from the proxy security group. Since traffic goes out with public[ NAT](https://en.wikipedia.org/wiki/Network_address_translation) IP as source, the source whitelist should include the public(outgoing) IP of NAT.

Refer to the security group requirements [here](https://docs.aws.amazon.com/eks/latest/userguide/sec-group-reqs.html) for updating the same.

As shown below for the unskript-dev cluster, the public access source allowlist is open to all traffic-

![](https://491011674-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fm4p7lGuBAXN5jCVyoF7P%2Fuploads%2FnTkIuDOgHFk8aXsXVcsq%2FC7898A9E-3A52-42FD-81B0-13C29A1DBD02.png?alt=media\&token=4972bfcb-0895-4cc2-b4f0-8781cd0ed338)

You can read[ here](https://docs.aws.amazon.com/eks/latest/userguide/cluster-endpoint.html) for further details on Amazon EKS cluster endpoint access control.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.unskript.com/unskript-documentation/connnecting/connectors/kubernetes.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
